// BonSrcDecoder.cpp: CBonSrcDecoder NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <TypeInfo.h>
#include "BonSrcDecoder.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


typedef IBonDriver* (PFCREATEBONDRIVER)(void);


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CBonSrcDecoder::CBonSrcDecoder(IEventHandler *pEventHandler)
	: CMediaDecoder(pEventHandler, 0UL, 1UL)
	, m_pBonDriver(NULL)
	, m_pBonDriver2(NULL)
	, m_hStreamRecvThread(NULL)
	, m_bKillSignal(false)
	, m_bPauseSignal(false)
	, m_bIsPlaying(false)
	, m_StreamRemain(0)
	, m_StreamThreadPriority(THREAD_PRIORITY_NORMAL)
	, m_bPurgeStreamOnChannelChange(true)
{
}

CBonSrcDecoder::~CBonSrcDecoder()
{
	CloseTuner();
}

void CBonSrcDecoder::Reset(void)
{
	if (m_pBonDriver == NULL)
		return;

	if (!LockStream()) {
		Trace(TEXT("Xg[MXbh܂B"));
		return;
	}

	// ̃Xg[j
	m_pBonDriver->PurgeTsStream();

	UnlockStream();
}

const bool CBonSrcDecoder::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	// \[XfR[_̂ߓ͂͏Ȃ
	return false;
}

const bool CBonSrcDecoder::OpenTuner(HMODULE hBonDrvDll)
{
	// I[v`FbN
	if (m_pBonDriver) {
		SetError(ERR_ALREADYOPEN,NULL);
		return false;
	}

	Trace(TEXT("`[iJĂ܂..."));

	// hCo|C^̎擾
	PFCREATEBONDRIVER *pf=(PFCREATEBONDRIVER*)::GetProcAddress(hBonDrvDll,"CreateBonDriver");
	if (pf == NULL) {
		SetError(ERR_DRIVER,TEXT("CreateBonDriver()̃AhX擾ł܂B"),
							TEXT("w肳ꂽDLLBonDriverł͂܂B"));
		return false;
	}
	if ((m_pBonDriver = pf()) == NULL) {
		SetError(ERR_DRIVER,TEXT("IBonDriver擾ł܂B"),
							TEXT("CreateBonDriver()̌ĂяoNULLԂ܂B"));
		return false;
	}

	HANDLE hThread = ::GetCurrentThread();
	int ThreadPriority = ::GetThreadPriority(hThread);

	// `[iJ
	if (!m_pBonDriver->OpenTuner()) {
		SetError(ERR_TUNEROPEN,TEXT("`[iJ܂B"),
							   TEXT("IBonDriver::OpenTuner()̌ĂяoŃG[Ԃ܂B"));
		goto OnError;
	}

	// BonDriver_HDUSAȂɃXbh̗DxHIGHESTɂ̂Ōɖ߂
	::SetThreadPriority(hThread, ThreadPriority);

	// IBonDriver2C^tF[X擾
	m_pBonDriver2 = dynamic_cast<IBonDriver2 *>(m_pBonDriver);

#if 0
	// `lZbg
	if (m_pBonDriver2) {
		// IBonDriver2
		if (!m_pBonDriver2->SetChannel(0UL, 0UL)) {
			m_dwLastError = ERR_TUNER;
			goto OnError;
		}
	} else {
		// IBonDriver
		if (!m_pBonDriver->SetChannel(13U)) {
			m_dwLastError = ERR_TUNER;
			goto OnError;
		}
	}
#endif

	// Xg[MXbhN
	m_bKillSignal = false;
	m_bPauseSignal = false;
	m_bIsPlaying = false;
	m_hStreamRecvThread = ::CreateThread(NULL, 0UL, CBonSrcDecoder::StreamRecvThread, this, 0UL, NULL);
	if (!m_hStreamRecvThread) {
		SetError(ERR_INTERNAL, TEXT("Xg[MXbh쐬ł܂B"));
		goto OnError;
	}

	ClearError();

	Trace(TEXT("`[iJ܂B"));

	return true;

OnError:
	m_pBonDriver->CloseTuner();
	m_pBonDriver->Release();
	m_pBonDriver = NULL;
	m_pBonDriver2 = NULL;
	return false;
}

const bool CBonSrcDecoder::CloseTuner(void)
{
	// Xg[~
	m_bIsPlaying = false;

	if (m_hStreamRecvThread) {
		// Xg[MXbh~
		Trace(TEXT("Xg[MXbh~Ă܂..."));
		m_bKillSignal = true;
		m_bPauseSignal = true;
		if (::WaitForSingleObject(m_hStreamRecvThread, 5000UL) != WAIT_OBJECT_0) {
			// XbhI
			::TerminateThread(m_hStreamRecvThread, 0UL);
			Trace(TEXT("Xg[MXbhȂߋI܂B"));
		}
		::CloseHandle(m_hStreamRecvThread);
		m_hStreamRecvThread = NULL;
	}

	if (m_pBonDriver) {
		// `[i
		Trace(TEXT("`[iĂ܂..."));
		m_pBonDriver->CloseTuner();

		// hCoCX^XJ
		Trace(TEXT("hCoĂ܂..."));
		m_pBonDriver->Release();
		m_pBonDriver = NULL;
		m_pBonDriver2 = NULL;
		Trace(TEXT("`[i܂B"));
	}

	ClearError();

	return true;
}

const bool CBonSrcDecoder::IsOpen() const
{
	return m_pBonDriver != NULL;
}

const bool CBonSrcDecoder::Play(void)
{
	TRACE(TEXT("CBonSrcDecoder::Play()\n"));

	if (m_pBonDriver == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if (m_bIsPlaying) {
		// ɍĐ
		/*
		SetError(ERR_ALREADYPLAYING,NULL);
		return false;
		*/
		return true;
	}

	if (!LockStream()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	m_pBonDriver->PurgeTsStream();

	// ʃfR[_Zbg
	ResetDownstreamDecoder();

	// Xg[ĐԂɂ
	m_bIsPlaying = true;

	UnlockStream();

	ClearError();

	return true;
}

const bool CBonSrcDecoder::Stop(void)
{
	TRACE(TEXT("CBonSrcDecoder::Stop()\n"));

	if (!m_bIsPlaying) {
		// Xg[͍ĐłȂ
		/*
		SetError(ERR_NOTPLAYING,NULL);
		return false;
		*/
		return true;
	}

	if (!LockStream()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	m_bIsPlaying = false;

	UnlockStream();

	ClearError();

	return true;
}

const bool CBonSrcDecoder::SetChannel(const BYTE byChannel)
{
	TRACE(TEXT("CBonSrcDecoder::SetChannel(%d)\n"), byChannel);

	if (m_pBonDriver == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if (!LockStream()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	if (m_bPurgeStreamOnChannelChange)
		m_pBonDriver->PurgeTsStream();

	// `lύX
	if (!m_pBonDriver->SetChannel(byChannel)) {
		UnlockStream();
		SetError(ERR_TUNER,TEXT("`l̕ύXł܂B"),
						   TEXT("IBonDriver::SetChannel()̌ĂяoŃG[Ԃ܂B"));
		return false;
	}

	// ʃfR[_Zbg
	ResetDownstreamDecoder();

	UnlockStream();

	ClearError();

	return true;
}

const bool CBonSrcDecoder::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	TRACE(TEXT("CBonSrcDecoder::SetChannel(%lu, %lu)\n"), dwSpace, dwChannel);

	if (m_pBonDriver2 == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if (!LockStream()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	if (m_bPurgeStreamOnChannelChange)
		m_pBonDriver2->PurgeTsStream();

	// `lύX
	if (!m_pBonDriver2->SetChannel(dwSpace, dwChannel)) {
		UnlockStream();
		SetError(ERR_TUNER,TEXT("`l̕ύXł܂B"),
						   TEXT("IBonDriver2::SetChannel()̌ĂяoŃG[Ԃ܂B"));
		return false;
	}

	// ʃfR[_Zbg
	ResetDownstreamDecoder();

	UnlockStream();

	ClearError();

	return true;
}

const bool CBonSrcDecoder::SetChannelAndPlay(const DWORD dwSpace, const DWORD dwChannel)
{
	TRACE(TEXT("CBonSrcDecoder::SetChannelAndPlay(%lu, %lu)\n"), dwSpace, dwChannel);

	if (m_pBonDriver2 == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if (!LockStream()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	if (m_bPurgeStreamOnChannelChange)
		m_pBonDriver2->PurgeTsStream();

	// `lύX
	if (!m_pBonDriver2->SetChannel(dwSpace, dwChannel)) {
		UnlockStream();
		SetError(ERR_TUNER,TEXT("`l̕ύXł܂B"),
						   TEXT("IBonDriver2::SetChannel()̌ĂяoŃG[Ԃ܂B"));
		return false;
	}

	// ʃfR[_Zbg
	ResetDownstreamDecoder();

	m_bIsPlaying = true;

	UnlockStream();

	ClearError();

	return true;
}

const float CBonSrcDecoder::GetSignalLevel(void)
{
	if (m_pBonDriver == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return 0.0f;
	}

	ClearError();

	// MxԂ
	return m_pBonDriver->GetSignalLevel();
}

const bool CBonSrcDecoder::IsBonDriver2(void) const
{
	// IBonDriver2C^tF[X̎gpۂԂ
	return m_pBonDriver2 != NULL;
}

LPCTSTR CBonSrcDecoder::GetSpaceName(const DWORD dwSpace) const
{
	// `[jOԖԂ
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return NULL;
	}
	return m_pBonDriver2->EnumTuningSpace(dwSpace);
}

LPCTSTR CBonSrcDecoder::GetChannelName(const DWORD dwSpace, const DWORD dwChannel) const
{
	// `lԂ
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return NULL;
	}
	return m_pBonDriver2->EnumChannelName(dwSpace, dwChannel);
}

const bool CBonSrcDecoder::PurgeStream(void)
{
	TRACE(TEXT("CBonSrcDecoder::PurgeStream()\n"));

	if (m_pBonDriver == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if (!LockStream()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	m_pBonDriver->PurgeTsStream();

	UnlockStream();

	ClearError();

	return true;
}


DWORD WINAPI CBonSrcDecoder::StreamRecvThread(LPVOID pParam)
{
	// `[iTSf[^oXbh
	CBonSrcDecoder *pThis = static_cast<CBonSrcDecoder *>(pParam);

	CMediaData TsStream(0x10000UL);

	::CoInitialize(NULL);

	::SetThreadPriority(::GetCurrentThread(),pThis->m_StreamThreadPriority);

	pThis->m_BitRateCalculator.Initialize();

	while (!pThis->m_bKillSignal) {
		// ȗ̂߃|[O̗p
		DWORD dwStreamRemain = 0UL;

		do {
			BYTE *pStreamData = NULL;
			DWORD dwStreamSize = 0UL;

			pThis->m_StreamLock.Lock();
			if (pThis->m_pBonDriver->GetTsStream(&pStreamData,&dwStreamSize,&dwStreamRemain)
					&& pStreamData && dwStreamSize) {
				if (pThis->m_bIsPlaying) {
					// ŏʃfR[_ɓ͂
					TsStream.SetData(pStreamData, dwStreamSize);
					pThis->OutputMedia(&TsStream);
				}
			}
			pThis->m_StreamLock.Unlock();

			pThis->m_StreamRemain=dwStreamRemain;
			pThis->m_BitRateCalculator.Update(dwStreamSize);

			if (pThis->m_bKillSignal)
				goto Break;
		} while (!pThis->m_bPauseSignal && dwStreamRemain > 0);
#if 1
		// EFCg(24MbpsƂĎ̃f[^܂Ŗ15ms)
		::Sleep(5UL);
#else
		// WaitTsStream ő҂ƕׂオ炵
		pThis->m_pBonDriver->WaitTsStream(20);
#endif
	}
Break:

	pThis->m_BitRateCalculator.Reset();

	::CoUninitialize();

	TRACE(TEXT("CBonSrcDecoder::StreamRecvThread() return\n"));

	return 0UL;
}


int CBonSrcDecoder::NumSpaces() const
{
	int i;

	for (i = 0; GetSpaceName(i) != NULL; i++);
	return i;
}


LPCTSTR CBonSrcDecoder::GetTunerName() const
{
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return NULL;
	}
	return m_pBonDriver2->GetTunerName();
}


int CBonSrcDecoder::GetCurSpace() const
{
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return -1;
	}
	return m_pBonDriver2->GetCurSpace();
}


int CBonSrcDecoder::GetCurChannel() const
{
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return -1;
	}
	return m_pBonDriver2->GetCurChannel();
}


DWORD CBonSrcDecoder::GetBitRate() const
{
	return m_BitRateCalculator.GetBitRate();
}


DWORD CBonSrcDecoder::GetStreamRemain() const
{
	return m_StreamRemain;
}


bool CBonSrcDecoder::SetStreamThreadPriority(int Priority)
{
	if (m_StreamThreadPriority != Priority) {
		TRACE(TEXT("CBonSrcDecoder::SetStreamThreadPriority(%d)\n"), Priority);
		if (m_hStreamRecvThread) {
			if (!::SetThreadPriority(m_hStreamRecvThread, Priority))
				return false;
		}
		m_StreamThreadPriority = Priority;
	}
	return true;
}


void CBonSrcDecoder::SetPurgeStreamOnChannelChange(bool bPurge)
{
	TRACE(TEXT("CBonSrcDecoder::SetPurgeStreamOnChannelChange(%s)\n"), bPurge ? TEXT("true") : TEXT("false"));
	m_bPurgeStreamOnChannelChange = bPurge;
}


bool CBonSrcDecoder::LockStream()
{
	m_bPauseSignal = true;
	bool bOK = m_StreamLock.TryLock(4000);
	m_bPauseSignal = false;
	return bOK;
}


void CBonSrcDecoder::UnlockStream()
{
	m_StreamLock.Unlock();
}
