#include "stdafx.h"
#include "RecTest.h"
#include "AppMain.h"
#include "UdpOptions.h"
#include "DialogUtil.h"
#include "resource.h"




CUdpOptions::CUdpOptions()
{
	GetAppClass().GetAppDirectory(m_szNetworkViewerPath);
	::PathAppend(m_szNetworkViewerPath,TEXT("TVTest.exe"));
	::lstrcpy(m_szNetworkViewerParameter,TEXT("/d BonDriver_UDP.dll /nd /port %port%"));
	m_szChasingViewerPath[0]='\0';
	::lstrcpy(m_szChasingViewerParameter,TEXT("\"%file%\""));
	m_StatusMode=STATUS_SENDANDVIEW;
	m_SocketType=CTsNetworkSender::SOCKET_UDP;
	::lstrcpy(m_szAddress,TEXT("127.0.0.1"));
	m_Port=1235;
	m_hPortMutex=NULL;
	m_RealPort=0;
	m_fSendCurServiceOnly=false;
	m_fSendSubtitle=true;
	m_fSendDataCarrousel=true;
}


CUdpOptions::~CUdpOptions()
{
	if (m_hPortMutex) {
		::ReleaseMutex(m_hPortMutex);
		::CloseHandle(m_hPortMutex);
	}
}


bool CUdpOptions::Read(CSettings *pSettings)
{
	pSettings->Read(TEXT("ViewerPath"),m_szNetworkViewerPath,lengthof(m_szNetworkViewerPath));
	pSettings->Read(TEXT("ViewerParameter"),m_szNetworkViewerParameter,lengthof(m_szNetworkViewerParameter));
	pSettings->Read(TEXT("ChasingViewerPath"),m_szChasingViewerPath,lengthof(m_szChasingViewerPath));
	pSettings->Read(TEXT("ChasingViewerParameter"),m_szChasingViewerParameter,lengthof(m_szChasingViewerParameter));
	int Status;
	if (pSettings->Read(TEXT("NetworkStatusMode"),&Status)
			&& Status>=0 && Status<=STATUS_LAST)
		m_StatusMode=(StatusMode)Status;
	int Protocol;
	if (pSettings->Read(TEXT("NetworkProtocol"),&Protocol)
			&& Protocol>=0 && Protocol<=1)
		m_SocketType=(CTsNetworkSender::SocketType)Protocol;
	pSettings->Read(TEXT("UdpSendAddress"),m_szAddress,lengthof(m_szAddress));
	pSettings->Read(TEXT("UdpSendPort"),&m_Port);
	CTsNetworkSender *pNetworkSender=&GetAppClass().GetCoreEngine()->m_DtvEngine.m_TsNetworkSender;
	unsigned int SendSize;
	if (pSettings->Read(TEXT("UdpSendSize"),&SendSize))
		pNetworkSender->SetSendSize(SendSize);
	unsigned int SendWait;
	if (pSettings->Read(TEXT("UdpSendWait"),&SendWait))
		pNetworkSender->SetSendWait(SendWait);
	bool fAdjustWait;
	if (pSettings->Read(TEXT("UdpAdjustWait"),&fAdjustWait))
		pNetworkSender->SetAdjustWait(fAdjustWait);
	pSettings->Read(TEXT("UdpSendCurServiceOnly"),&m_fSendCurServiceOnly);
	pSettings->Read(TEXT("NetworkSendSubtitle"),&m_fSendSubtitle);
	pSettings->Read(TEXT("NetworkSendDataCarrousel"),&m_fSendDataCarrousel);
	return true;
}


bool CUdpOptions::Write(CSettings *pSettings) const
{
	pSettings->Write(TEXT("ViewerPath"),m_szNetworkViewerPath);
	pSettings->Write(TEXT("ViewerParameter"),m_szNetworkViewerParameter);
	pSettings->Write(TEXT("ChasingViewerPath"),m_szChasingViewerPath);
	pSettings->Write(TEXT("ChasingViewerParameter"),m_szChasingViewerParameter);
	pSettings->Write(TEXT("NetworkStatusMode"),(int)m_StatusMode);
	pSettings->Write(TEXT("NetworkProtocol"),(int)m_SocketType);
	pSettings->Write(TEXT("UdpSendAddress"),m_szAddress);
	pSettings->Write(TEXT("UdpSendPort"),m_Port);
	const CTsNetworkSender *pNetworkSender=&GetAppClass().GetCoreEngine()->m_DtvEngine.m_TsNetworkSender;
	pSettings->Write(TEXT("UdpSendSize"),(unsigned int)pNetworkSender->GetSendSize());
	pSettings->Write(TEXT("UdpSendWait"),(unsigned int)pNetworkSender->GetSendWait());
	pSettings->Write(TEXT("UdpAdjustWait"),pNetworkSender->GetAdjustWait());
	pSettings->Write(TEXT("UdpSendCurServiceOnly"),m_fSendCurServiceOnly);
	pSettings->Write(TEXT("NetworkSendSubtitle"),m_fSendSubtitle);
	pSettings->Write(TEXT("NetworkSendDataCarrousel"),m_fSendDataCarrousel);
	return true;
}


bool CUdpOptions::ExecuteViewer(LPCTSTR pszViewerPath,LPCTSTR pszParameter) const
{
	TCHAR szCommandLine[MAX_PATH*2];
	int i;
	LPCTSTR p;

	if (pszViewerPath[0]=='\0')
		return false;

	::lstrcpy(szCommandLine,pszViewerPath);
	::PathQuoteSpaces(szCommandLine);
	if (pszParameter[0]!='\0') {
		p=pszParameter;
		i=::lstrlen(szCommandLine);
		szCommandLine[i++]=' ';
		do {
			if (*p=='%') {
				if (::StrCmpNI(p,TEXT("%port%"),6)==0) {
					i+=::wsprintf(szCommandLine+i,TEXT("%d"),
								  m_RealPort!=0?m_RealPort:m_Port);
					p+=6;
				} else if (::StrCmpNI(p,TEXT("%file%"),6)==0) {
					const CRecordManager *pRecordManager=GetAppClass().GetRecordManager();
					if (pRecordManager->IsRecording()) {
						i+=::wsprintf(szCommandLine+i,TEXT("%s"),pRecordManager->GetFileName());
					} else {
						// "ň͂܂Ăꍇ͏
						if (szCommandLine[i-1]=='"')
							i--;
						if (*(p+6)=='"')
							p++;
					}
					p+=6;
				} else {
					szCommandLine[i++]=*p;
					do {
						p++;
						szCommandLine[i++]=*p;
					} while (*p!='%' && *p!='\0');
					if (*p!='\0')
						p++;
				}
			} else {
				szCommandLine[i++]=*p++;
			}
		} while (*p!='\0');
		szCommandLine[i]='\0';
	}
	GetAppClass().AddLog(TEXT("vON܂B (%s)"),szCommandLine);
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	::ZeroMemory(&si,sizeof(si));
	si.cb=sizeof(si);
	::ZeroMemory(&pi,sizeof(pi));
	if (!::CreateProcess(NULL,szCommandLine,NULL,NULL,FALSE,0,NULL,NULL,&si,&pi)) {
		GetAppClass().AddLog(TEXT("vONł܂B"));
		return false;
	}
	::CloseHandle(pi.hProcess);
	::CloseHandle(pi.hThread);
	return true;
}


bool CUdpOptions::ExecuteNetworkViewer() const
{
	return ExecuteViewer(m_szNetworkViewerPath,m_szNetworkViewerParameter);
}


bool CUdpOptions::ExecuteChasingViewer() const
{
	return ExecuteViewer(m_szChasingViewerPath,m_szChasingViewerParameter);
}


bool CUdpOptions::StartNetworkSend(int Protocol,unsigned int Port)
{
	CTsNetworkSender::AddressInfo AddressInfo;
	char szAddr[64];

	if (m_szAddress[0]=='\0' || m_Port==0)
		return false;

	if (m_hPortMutex!=NULL) {
		::ReleaseMutex(m_hPortMutex);
		::CloseHandle(m_hPortMutex);
		m_hPortMutex=NULL;
	}

	GetAppClass().GetCoreEngine()->m_DtvEngine.SetSendCurServiceOnly(m_fSendCurServiceOnly);

	TCHAR szName[64];
	if (Port==0)
		Port=m_Port;
	while (true) {
		::wsprintf(szName,APP_NAME TEXT(" Network Port %u"),Port);
		HANDLE hMutex=::OpenMutex(MUTEX_ALL_ACCESS,FALSE,szName);
		if (hMutex==NULL)
			break;
		::CloseHandle(hMutex);
		Port++;
	}
	SECURITY_DESCRIPTOR sd;
	SECURITY_ATTRIBUTES sa;
	::ZeroMemory(&sd,sizeof(sd));
	::InitializeSecurityDescriptor(&sd,SECURITY_DESCRIPTOR_REVISION);
	::SetSecurityDescriptorDacl(&sd,TRUE,NULL,FALSE);
	::ZeroMemory(&sa,sizeof(sa));
	sa.nLength=sizeof(sa);
	sa.lpSecurityDescriptor=&sd;
	m_hPortMutex=::CreateMutex(&sa,TRUE,szName);

	::WideCharToMultiByte(CP_ACP,0,m_szAddress,-1,szAddr,lengthof(szAddr),NULL,NULL);
	if (Protocol==PROTOCOL_DEFAULT) {
		AddressInfo.Type=m_SocketType;
	} else {
		AddressInfo.Type=Protocol==PROTOCOL_UDP?
			CTsNetworkSender::SOCKET_UDP:CTsNetworkSender::SOCKET_TCP;
	}
	AddressInfo.pszAddress=szAddr;
	AddressInfo.Port=Port;
	GetAppClass().AddLog(TEXT("lbg[NMJn܂B(%s %s:%d)"),
						 AddressInfo.Type==CTsNetworkSender::SOCKET_UDP?TEXT("UDP"):TEXT("TCP"),m_szAddress,Port);
	if (!GetAppClass().GetCoreEngine()->m_DtvEngine.StartNetworkSend(&AddressInfo,1)) {
		GetAppClass().AddLog(TEXT("lbg[NMJnł܂B"));
		return false;
	}
	m_RealPort=Port;
	return true;
}


bool CUdpOptions::StopNetworkSend()
{
	if (m_RealPort==0)
		return true;
	if (m_hPortMutex!=NULL) {
		::ReleaseMutex(m_hPortMutex);
		::CloseHandle(m_hPortMutex);
		m_hPortMutex=NULL;
	}
	m_RealPort=0;
	GetAppClass().AddLog(TEXT("lbg[NMI܂B"));
	return GetAppClass().GetCoreEngine()->m_DtvEngine.StopNetworkSend();
}


bool CUdpOptions::IsNetworkSending() const
{
	return m_RealPort>0;
}


int CUdpOptions::GetProtocol() const
{
	if (m_SocketType==CTsNetworkSender::SOCKET_UDP)
		return PROTOCOL_UDP;
	return PROTOCOL_TCP;
}


CUdpOptions *CUdpOptions::GetThis(HWND hDlg)
{
	return static_cast<CUdpOptions*>(GetOptions(hDlg));
}


INT_PTR CALLBACK CUdpOptions::DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static struct {
		int CurSel;
		TCHAR szNetworkViewerPath[MAX_PATH];
		TCHAR szNetworkViewerParameter[MAX_PARAMETER];
		TCHAR szChasingViewerPath[MAX_PATH];
		TCHAR szChasingViewerParameter[MAX_PARAMETER];
	} CurViewerSettings;

	switch (uMsg) {
	case WM_INITDIALOG:
		{
			CUdpOptions *pThis=static_cast<CUdpOptions*>(OnInitDialog(hDlg,lParam));

			static const LPCTSTR pszViewerType[] = {
				TEXT("lbg[NvO"),
				TEXT("t@CĐvO"),
			};
			for (int i=0;i<lengthof(pszViewerType);i++)
				DlgComboBox_AddString(hDlg,IDC_VIEWEROPTIONS_TYPE,pszViewerType[i]);
			DlgComboBox_SetCurSel(hDlg,IDC_VIEWEROPTIONS_TYPE,0);
			::SetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPATH,pThis->m_szNetworkViewerPath);
			::SetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPARAMETER,pThis->m_szNetworkViewerParameter);
			CurViewerSettings.CurSel=0;
			::lstrcpy(CurViewerSettings.szNetworkViewerPath,pThis->m_szNetworkViewerPath);
			::lstrcpy(CurViewerSettings.szNetworkViewerParameter,pThis->m_szNetworkViewerParameter);
			::lstrcpy(CurViewerSettings.szChasingViewerPath,pThis->m_szChasingViewerPath);
			::lstrcpy(CurViewerSettings.szChasingViewerParameter,pThis->m_szChasingViewerParameter);
			static const LPCTSTR pszStatusMode[] = {
				TEXT("Ȃ"),
				TEXT("lbg[NM+"),
				TEXT("lbg[NM"),
				TEXT("lbg[NvON"),
				TEXT("t@CĐvON"),
			};
			for (int i=0;i<lengthof(pszStatusMode);i++)
				DlgComboBox_AddString(hDlg,IDC_NETWORKOPTIONS_STATUSMODE,pszStatusMode[i]);
			DlgComboBox_SetCurSel(hDlg,IDC_NETWORKOPTIONS_STATUSMODE,pThis->m_StatusMode);
			CheckRadioButton(hDlg,IDC_NETWORKOPTIONS_PROTOCOL_UDP,
								  IDC_NETWORKOPTIONS_PROTOCOL_TCP,
							 pThis->m_SocketType==CTsNetworkSender::SOCKET_UDP?
								  IDC_NETWORKOPTIONS_PROTOCOL_UDP:
								  IDC_NETWORKOPTIONS_PROTOCOL_TCP);
			::SetDlgItemText(hDlg,IDC_UDPOPTIONS_ADDRESS,pThis->m_szAddress);
			::SetDlgItemInt(hDlg,IDC_UDPOPTIONS_PORT,pThis->m_Port,FALSE);
			::SendDlgItemMessage(hDlg,IDC_UDPOPTIONS_PORT_UD,UDM_SETRANGE32,
								 1,0xFFFF);
			const CTsNetworkSender *pNetworkSender=&GetAppClass().GetCoreEngine()->m_DtvEngine.m_TsNetworkSender;
			::SetDlgItemInt(hDlg,IDC_UDPOPTIONS_SENDSIZE,pNetworkSender->GetSendSize(),FALSE);
			::SendDlgItemMessage(hDlg,IDC_UDPOPTIONS_SENDSIZE_UD,UDM_SETRANGE32,
								 1,0xFFFF);
			::SetDlgItemInt(hDlg,IDC_UDPOPTIONS_SENDWAIT,pNetworkSender->GetSendWait(),FALSE);
			::SendDlgItemMessage(hDlg,IDC_UDPOPTIONS_SENDWAIT_UD,UDM_SETRANGE32,
								 0,0xFFFF);
			DlgCheckBox_Check(hDlg,IDC_NETWORKOPTIONS_ADJUSTWAIT,pNetworkSender->GetAdjustWait());
			DlgCheckBox_Check(hDlg,IDC_UDPOPTIONS_SENDCURSERVICEONLY,pThis->m_fSendCurServiceOnly);
			DlgCheckBox_Check(hDlg,IDC_NETWORKOPTIONS_SENDSUBTITLE,pThis->m_fSendSubtitle);
			DlgCheckBox_Check(hDlg,IDC_NETWORKOPTIONS_SENDDATACARROUSEL,pThis->m_fSendDataCarrousel);
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_VIEWEROPTIONS_TYPE:
			if (HIWORD(wParam)==CBN_SELCHANGE
					&& DlgComboBox_GetCurSel(hDlg,IDC_VIEWEROPTIONS_TYPE)!=CurViewerSettings.CurSel) {
				LPTSTR pszOldPath,pszOldParameter;
				LPCTSTR pszNewPath,pszNewParameter;

				if (CurViewerSettings.CurSel==0) {
					pszOldPath=CurViewerSettings.szNetworkViewerPath;
					pszOldParameter=CurViewerSettings.szNetworkViewerParameter;
					pszNewPath=CurViewerSettings.szChasingViewerPath;
					pszNewParameter=CurViewerSettings.szChasingViewerParameter;
				} else {
					pszOldPath=CurViewerSettings.szChasingViewerPath;
					pszOldParameter=CurViewerSettings.szChasingViewerParameter;
					pszNewPath=CurViewerSettings.szNetworkViewerPath;
					pszNewParameter=CurViewerSettings.szNetworkViewerParameter;
				}
				::GetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPATH,pszOldPath,MAX_PATH);
				::GetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPARAMETER,pszOldParameter,MAX_PARAMETER);
				::SetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPATH,pszNewPath);
				::SetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPARAMETER,pszNewParameter);
				CurViewerSettings.CurSel=!CurViewerSettings.CurSel;
			}
			return TRUE;

		case IDC_VIEWEROPTIONS_VIEWERPATH_BROWSE:
			{
				OPENFILENAME ofn;
				TCHAR szFileName[MAX_PATH],szInitialDir[MAX_PATH];

				::GetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPATH,
								 szFileName,lengthof(szFileName));
				ofn.lStructSize=sizeof(OPENFILENAME);
				ofn.hwndOwner=hDlg;
				ofn.lpstrFilter=TEXT("st@C(*.exe)\0*.exe\0")
								TEXT("ׂẴt@C\0*.*\0");
				ofn.lpstrCustomFilter=NULL;
				ofn.nFilterIndex=1;
				ofn.lpstrFile=szFileName;
				ofn.nMaxFile=lengthof(szFileName);
				ofn.lpstrFileTitle=NULL;
				if (szFileName[0]=='\0' || ::PathIsFileSpec(szFileName)) {
					::GetModuleFileName(NULL,szInitialDir,lengthof(szInitialDir));
					*(::PathFindFileName(szInitialDir)-1)='\0';
					ofn.lpstrInitialDir=szInitialDir;
				} else
					ofn.lpstrInitialDir=NULL;
				ofn.lpstrTitle=TEXT("vO");
				ofn.Flags=OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
				ofn.lpstrDefExt=TEXT("exe");
#if _WIN32_WINNT>=0x500
				ofn.pvReserved=NULL;
				ofn.dwReserved=0;
				ofn.FlagsEx=0;
#endif
				if (::GetOpenFileName(&ofn))
					::SetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPATH,szFileName);
			}
			return TRUE;
		}
		return TRUE;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case PSN_APPLY:
			{
				CUdpOptions *pThis=GetThis(hDlg);
				CTsNetworkSender *pNetworkSender=&GetAppClass().GetCoreEngine()->m_DtvEngine.m_TsNetworkSender;

				LPTSTR pszPath,pszParameter;
				if (CurViewerSettings.CurSel==0) {
					pszPath=CurViewerSettings.szNetworkViewerPath;
					pszParameter=CurViewerSettings.szNetworkViewerParameter;
				} else {
					pszPath=CurViewerSettings.szChasingViewerPath;
					pszParameter=CurViewerSettings.szChasingViewerParameter;
				}
				::GetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPATH,pszPath,MAX_PATH);
				::GetDlgItemText(hDlg,IDC_VIEWEROPTIONS_VIEWERPARAMETER,pszParameter,MAX_PARAMETER);
				::lstrcpy(pThis->m_szNetworkViewerPath,CurViewerSettings.szNetworkViewerPath);
				::lstrcpy(pThis->m_szNetworkViewerParameter,CurViewerSettings.szNetworkViewerParameter);
				::lstrcpy(pThis->m_szChasingViewerPath,CurViewerSettings.szChasingViewerPath);
				::lstrcpy(pThis->m_szChasingViewerParameter,CurViewerSettings.szChasingViewerParameter);
				pThis->m_SocketType=
					::IsDlgButtonChecked(hDlg,IDC_NETWORKOPTIONS_PROTOCOL_UDP)?
						CTsNetworkSender::SOCKET_UDP:CTsNetworkSender::SOCKET_TCP;
				pThis->m_StatusMode=(StatusMode)DlgComboBox_GetCurSel(hDlg,IDC_NETWORKOPTIONS_STATUSMODE);
				TCHAR szAddress[64];
				::GetDlgItemText(hDlg,IDC_UDPOPTIONS_ADDRESS,szAddress,lengthof(szAddress));
				unsigned int Port=::GetDlgItemInt(hDlg,IDC_UDPOPTIONS_PORT,NULL,FALSE);
				if (::lstrcmp(szAddress,pThis->m_szAddress)!=0
						|| Port!=pThis->m_Port) {
					::lstrcpy(pThis->m_szAddress,szAddress);
					pThis->m_Port=Port;
					if (szAddress[0]!='\0' && Port!=0 && pNetworkSender->IsOpen())
						pThis->StartNetworkSend();
				}
				unsigned int SendSize=::GetDlgItemInt(hDlg,IDC_UDPOPTIONS_SENDSIZE,NULL,FALSE);
				pNetworkSender->SetSendSize(SendSize);
				pNetworkSender->SetSendWait(::GetDlgItemInt(hDlg,IDC_UDPOPTIONS_SENDWAIT,NULL,FALSE));
				pNetworkSender->SetAdjustWait(DlgCheckBox_IsChecked(hDlg,IDC_NETWORKOPTIONS_ADJUSTWAIT));
				pThis->m_fSendCurServiceOnly=
					DlgCheckBox_IsChecked(hDlg,IDC_UDPOPTIONS_SENDCURSERVICEONLY);
				pThis->m_fSendSubtitle=
					DlgCheckBox_IsChecked(hDlg,IDC_NETWORKOPTIONS_SENDSUBTITLE);
				pThis->m_fSendDataCarrousel=
					DlgCheckBox_IsChecked(hDlg,IDC_NETWORKOPTIONS_SENDDATACARROUSEL);
				DWORD Stream=CTsSelector::STREAM_ALL;
				if (!pThis->m_fSendSubtitle)
					Stream^=CTsSelector::STREAM_SUBTITLE;
				if (!pThis->m_fSendDataCarrousel)
					Stream^=CTsSelector::STREAM_DATACARROUSEL;
				GetAppClass().GetCoreEngine()->m_DtvEngine.SetSendCurServiceOnly(pThis->m_fSendCurServiceOnly,Stream);
			}
			break;
		}
		break;

	case WM_DESTROY:
		{
			CUdpOptions *pThis=GetThis(hDlg);

			pThis->OnDestroy();
		}
		return TRUE;
	}
	return FALSE;
}
