#ifndef UDP_OPTIONS_H
#define UDP_OPTIONS_H


#include "Options.h"
#include "Settings.h"
#include "TsNetworkSender.h"


class CUdpOptions : public COptions {
public:
	enum StatusMode {
		STATUS_NONE,
		STATUS_SENDANDVIEW,
		STATUS_SEND,
		STATUS_NETWORKVIEW,
		STATUS_CHASINGVIEW,
		STATUS_LAST=STATUS_CHASINGVIEW
	};
private:
	enum { MAX_PARAMETER=128 };
	TCHAR m_szNetworkViewerPath[MAX_PATH];
	TCHAR m_szNetworkViewerParameter[MAX_PARAMETER];
	TCHAR m_szChasingViewerPath[MAX_PATH];
	TCHAR m_szChasingViewerParameter[MAX_PARAMETER];
	StatusMode m_StatusMode;
	CTsNetworkSender::SocketType m_SocketType;
	TCHAR m_szAddress[64];
	unsigned int m_Port;
	HANDLE m_hPortMutex;
	unsigned int m_RealPort;
	bool m_fSendCurServiceOnly;
	bool m_fSendSubtitle;
	bool m_fSendDataCarrousel;
	bool ExecuteViewer(LPCTSTR pszViewerPath,LPCTSTR pszParameter) const;
	static CUdpOptions *GetThis(HWND hDlg);
public:
	CUdpOptions();
	~CUdpOptions();
	bool Read(CSettings *pSettings);
	bool Write(CSettings *pSettings) const;
	bool ExecuteNetworkViewer() const;
	bool ExecuteChasingViewer() const;
	enum {
		PROTOCOL_DEFAULT=-1,
		PROTOCOL_UDP,
		PROTOCOL_TCP
	};
	bool StartNetworkSend(int Protocol=PROTOCOL_DEFAULT,unsigned int Port=0);
	bool StopNetworkSend();
	bool IsNetworkSending() const;
	int GetProtocol() const;
	unsigned int GetSendingPort() const { return m_RealPort; }
	StatusMode GetStatusMode() const { return m_StatusMode; }
	static INT_PTR CALLBACK DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
};


#endif
